Subject: ptkdb Release 1.04, Debugger for Perl with pTk GUI
From: [email-masked] (Andrew E Page)
Date: 28 Aug 1998 14:51:55 GMT
Newsgroups: comp.lang.perl.announce,comp.lang.perl.tk

ptkdb  A  Perl debugger with Graphical User Interface

You can find this utility with at:

<a href="http://world.std.com/~aep/ptkdb">

http://world.std.com/~aep/ptkdb

</a>

http://world.std.com/~aep/ptkdb

   Included are links to binaries for perl for Win95/NT with Tk installed, and the
latest distributions for perlTk. 

New Version 1.04

RELEASE NOTES:

Major increase in speed for scripts operating under ptkdb.  The speed
is now equal to that of the default perl debugger.   ptkdb is  now
coupled much more tightly to the perl interpreter.  

Standard Makefile.PL installation option

Distributions moved to CPAN area.

Text in Code window is now 'Read Only'

Undo has been enabled for the Expression Eval window.

A KNOWN PROBLEM:

  You get a "line N in myscript.pl not breakable" alert where you
SWEAR there's an executable line of code.

Example:

00001 
00002 my($mysub) ;
00003 
00004 $mysub = sub {
00005       print "Hello World\n" ;
00006 } ;
00007 
00008 &$mysub ;
00009 

   If you try to set a breakpoint on line 4 you will get the alert
mentioned above. HOWEVER, if you try to set the breakpoint on line 6,
you will be setting a break on the operation that appears on line
4. That is where the operation is 'syntactically' completed.

An upcoming version of ptkdb(after 1.04) will be tagging 'unbreakable'
lines numbers with:

tagConfigure("unbreakableLine", -overstrike => TRUE) 

UPCOMING FEATURES:

   The pushbutton controls for breakpoints will be eliminated.
Instead, you will click on the line numbers to set, unset, enable,
disable the breakpoints.  The line numbers will change color/format to
reflect breakpoint status.

    Configuration for the look and feel of the interface will be
moving out of the environmental variables and into the Tk/X options,
provided of course that I can make this portable for Win32 users.
    A script will be provided to convert existing environmental variables
to Tk/X options.  

    I'm working on a way to provide a breakpoint control panel that
will allow you to see all existing breakpoints and set breakpoints on
defined subroutines.  This will most likely take the form of a
Tk::Notebook page.

    Increased support for debugging other Tk applications.  This has
required to development of a ptkdb.so file.  This is proving to be a
somewhat difficult task, but it is in progress.  I have code that
filters events from the application when stopped in the debugger, and
from the debugger when the application is running.  The difficulty at
present is getting it portable to all systems.  In addition I wish to
find a way to make this an 'optional' installation feature.  One of
the better aspects of ptkdb(at the moment) is that is written purely
in perl and pTk.

    When I get the chance I'm going to be putting up a "Credits" section
on the web page to give credit to people in the community for testing
and other favors.  

-- 
Andrew E. Page   (Warrior Poet) |   Decision and Effort The Archer and Arrow
Software Engineering Consultant |     The difference between what we are
Unix, Mac, C/C++/Java, Perl, NT |           and what we want to be.